module c_1_3(
   clk      ,
   rst_n    ,
   en1      ,
   en2      ,
   dout       
);


input             clk      ;
input             rst_n    ;
input             en1      ;
input             en2      ;
output            dout     ;

reg               dout     ;
reg     [3:0]     cnt      ;
reg     [3:0]     x        ;
reg     [2:0]     flag_sel ;
wire              add_cnt  ;
wire              end_cnt  ;


always @(posedge clk or negedge rst_n)begin
    if(!rst_n)begin
        cnt <= 0;
    end
    else if(add_cnt)begin
        if(end_cnt)
            cnt <= 0;
        else
            cnt <= cnt + 1;
    end
end

assign add_cnt = dout==0;       
assign end_cnt = add_cnt && cnt== x-1;

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        flag_sel <= 0;
    end
    else if(en1)begin
        flag_sel <= 1;
    end
    else if(en2)begin
        flag_sel <= 0;
    end
end


always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        dout <= 1;
    end
    else if(en1 || en2)begin
        dout <= 0;
    end
    else if(end_cnt)begin
        dout <= 1;
    end
end


always  @(*)begin
    if(flag_sel==0)
        x = 5;
    else
        x = 7;
end


endmodule
