module c_1_6(
   clk      ,
   rst_n    ,
   en1      ,
   en2      ,
   dout       
);


input             clk      ;
input             rst_n    ;
input             en1      ;
input             en2      ;
output            dout     ;

reg               dout     ;
reg     [4:0]     cnt      ;
reg               flag_add ;
reg               flag_sel ;
reg     [4:0]     x        ;
reg     [4:0]     y        ;
wire              add_cnt  ;
wire              end_cnt  ;


always @(posedge clk or negedge rst_n)begin
    if(!rst_n)begin
        cnt <= 0;
    end
    else if(add_cnt)begin
        if(end_cnt)
            cnt <= 0;
        else
            cnt <= cnt + 1;
    end
end

assign add_cnt = flag_add;       
assign end_cnt = add_cnt && cnt== x-1; 

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        flag_add <= 0;
    end
    else if(en1 || en2)begin
        flag_add <= 1;
    end
    else if(end_cnt)begin
        flag_add <= 0;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        flag_sel <= 0;
    end
    else if(en1)begin
        flag_sel <= 0;
    end
    else if(en2)begin
        flag_sel <= 1;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        dout <= 0;
    end
    else if(add_cnt && cnt==y-1)begin
        dout <= 1;
    end
    else if(end_cnt)begin
        dout <= 0;
    end
end


always  @(*)begin
    if(flag_sel==0)begin
        x = 11;
        y = 10;
    end
    else begin
        x = 12;
        y = 5;
    end
end
endmodule

